function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _require = require('webassembly-interpreter'),
    instantiateFromSource = _require.instantiateFromSource;

function wast(string) {
  var program = "\n    (module ".concat(string, ")\n  ");
  var instance = instantiateFromSource(program);
  return instance.exports;
}

function wastInstructions(strings) {
  for (var _len = arguments.length, params = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    params[_key - 1] = arguments[_key];
  }

  if (typeof strings === 'string') {
    throw new TypeError("wastInstructions: please use the tagged template");
  }

  var code = strings.reduce(function (acc, string) {
    var param = '';

    if (params.length !== 0) {
      param = params.pop();

      if (typeof param !== 'number') {
        throw new TypeError('Unexpected variable of type: ' + _typeof(param));
      }
    }

    acc += string + param;
    return acc;
  }, '');
  var res = wast("\n    (func (export \"main\") (result i32) ".concat(code, ")\n  "));
  return function () {
    return res.main.apply(res, params);
  };
}

module.exports = {
  wast: wast,
  wastInstructions: wastInstructions
};