function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var libwabt = require('./libwabt');

function run(_ref) {
  var buffer = _ref.buffer;
  var module = new WebAssembly.Module(buffer);
  var instance = new WebAssembly.Instance(module);
  return instance;
}

function wastToWasm(script) {
  var module = libwabt.parseWat('inline.wast', script);
  return module;
}

function wast(string) {
  var program = wastToWasm("\n    (module ".concat(string, ")\n  "));
  program.resolveNames();
  program.validate();
  var binaryOutput = program.toBinary({
    log: true,
    write_debug_names: true
  });
  var instance = run(binaryOutput);
  return instance.exports;
}

function wastInstructions(strings) {
  for (var _len = arguments.length, params = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    params[_key - 1] = arguments[_key];
  }

  if (typeof strings === 'string') {
    throw new TypeError("wastInstructions: please use the tagged template");
  }

  var code = strings.reduce(function (acc, string) {
    var param = '';

    if (params.length !== 0) {
      param = params.pop();

      if (typeof param !== 'number') {
        throw new TypeError('Unexpected variable of type: ' + _typeof(param));
      }
    }

    acc += string + param;
    return acc;
  }, '');
  var res = wast("\n    (func (export \"main\") (result i32) ".concat(code, ")\n  "));
  return function () {
    return res.main.apply(res, params);
  };
}

module.exports = {
  wast: wast,
  wastInstructions: wastInstructions
};